/* mac-fix-env: A small utility to pick up the shell environment on MacOS X
                and insert it into the file ~/.MacOSX/environment.plist
                creating if necessary.
   usage:
          Run from command line (in Terminal) once or whenever path changes:

   /Applications/Emacs.app/Contents/MacOS/bin/mac-fix-env

   (change initial part to where you installed Emacs).
*/

#import <Foundation/Foundation.h>
#include <stdlib.h>

int main(int argc, char *argv[])
{
    NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
    NSMutableDictionary *envPlist;
    NSString *file = [[NSHomeDirectory()
                         stringByAppendingPathComponent:@".MacOSX"]
                         stringByAppendingPathComponent:@"environment.plist"];
    NSString *path = [NSString stringWithCString: getenv("PATH")];

    envPlist = [[NSDictionary dictionaryWithContentsOfFile: file] mutableCopy];
    if (envPlist == nil)
      {
        // create
        NSString *dir = [file stringByDeletingLastPathComponent];
        envPlist = [NSMutableDictionary dictionaryWithCapacity: 5];

        if ([[NSFileManager defaultManager] fileExistsAtPath: dir] == NO)
          {
            if ([[NSFileManager defaultManager] createDirectoryAtPath:dir
                                                           attributes:nil]==NO)
              {
                NSLog(@":\nCould not create directory at '%@'; aborting.",dir);
                return 1;
              }
          }
      }

    [envPlist setObject: path forKey: @"PATH"];

    if ([envPlist writeToFile: file atomically: YES] == NO)
      {
        NSLog(@":\nCould not write file at '%@'; aborting.", file);
        return 1;
      }

    NSLog(@":\nWrote file to '%@'.\nPlease inspect it to make sure PATH is correct.", file);
    return 0;
}
